//
//  AppDelegate.m
//  TestURLCache
//
//  Created by Ben Blaukopf on 10/10/2014.
//  Copyright (c) 2014 airsource. All rights reserved.
//

#import "AppDelegate.h"
#import "ViewController.h"
@interface MyCache : NSURLCache
@end

@implementation MyCache
-(NSCachedURLResponse*)cachedResponseForRequest:(NSURLRequest *)request
{
    NSCachedURLResponse *response = [super cachedResponseForRequest:request];
    NSLog(@"Retrieved %@", response);
    return response;
}

-(void)storeCachedResponse:(NSCachedURLResponse *)cachedResponse forRequest:(NSURLRequest *)request
{
    NSLog(@"Store %@", cachedResponse);
    [super storeCachedResponse:cachedResponse forRequest:request];
}

@end

@interface AppDelegate ()

@end

@implementation AppDelegate


- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {
    // Override point for customization after application launch.
    NSUInteger sz =CACHE_SIZE;
    NSURLCache *cache = [[MyCache alloc] initWithMemoryCapacity:1000000 diskCapacity:sz diskPath:@"nsurlcache"];
    assert(cache);
    [NSURLCache setSharedURLCache:cache];
    // This apparently has no effect on iOS 7, whether done before or after the setSharedURLCache line
    // However, on iOS 8 it works fine.
    // BUT on iOS 8 it will not remove cached responses that would never have been stored in the cache.
    //[cache removeAllCachedResponses];
    
    // Start by using default cache.
    return YES;
}

- (void)applicationWillResignActive:(UIApplication *)application {
    // Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
    // Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
}

- (void)applicationDidEnterBackground:(UIApplication *)application {
    // Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later.
    // If your application supports background execution, this method is called instead of applicationWillTerminate: when the user quits.
}

- (void)applicationWillEnterForeground:(UIApplication *)application {
    // Called as part of the transition from the background to the inactive state; here you can undo many of the changes made on entering the background.
}

- (void)applicationDidBecomeActive:(UIApplication *)application {
    // Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
}

- (void)applicationWillTerminate:(UIApplication *)application {
    // Called when the application is about to terminate. Save data if appropriate. See also applicationDidEnterBackground:.
}

@end
